var Countdown = {
    
    seconds: 0,
    frames: 0,
    
    mode: 'stopped',
    
    finished_callback: null,
    
    init: function() {
        const style = new PIXI.TextStyle({
        fontFamily: 'Gajraj One',
        fontSize: 36,
        fontWeight: 'bold',
        fill: ['#ff0000', '#ff4433'], // gradient
        stroke: 'yellow',
        strokeThickness: 5,
        lineJoin: 'round',
        });
        
        this.label = new PIXI.Text('00:00', style);
    },
    
    count: function(delta) {
        if (this.mode == 'stopped') return;
        this.frames -= delta;
        while (this.frames < 0) {
            this.frames += 60;
            this.seconds -= 1;
        }
        if (this.seconds < 0) {
            this.label.text = '0:00';
            this.mode = 'stopped';
            if (typeof this.finished_callback == 'function') this.finished_callback();
        } else {
            var frames = Math.floor(this.frames);
            this.label.text = this.seconds+':'+(frames > 9 ? frames : '0'+frames);
        }
    },
    
    stop: function() {
        this.mode = 'stopped';
    },
    
    reset: function(seconds) {
        this.frames = 0;
        this.seconds = seconds;
        this.mode = 'counting';
    }
}